// HTML2EMail
// email class
// (c)2002,2003 Oliver Michalak / werk01.de

function EMail () {
	this.soc = false;
	this.smtpHost = '';
	this.smtpAfterPop = false;
	this.popHost = '';
	this.popUser = '';
	this.popPasswd = '';
	this.from = '';
	this.to = '';
	this.header = new Array();
	this.data = '';
	this.error = '';
}

EMail.prototype.set = function (key, value) {
	switch (key) {
		case 'smtpHost':
		case 'host':
			this.smtpHost = value;
			break;
		case 'popHost':
			this.popHost = value;
			break;
		case 'user':
			this.popUser = value;
			break;
		case 'passwd':
			this.popPasswd = value;
			break;
		case 'from':
			this.from = value;
			break;
		case 'to':
			this.to = value;
			break;
		case 'data':
			this.data = value;
			break;
		default:
			this.header[key] = value;
	}
}

EMail.prototype.authenticate = function (value) {
	this.smtpAfterPop = value;
}

EMail.prototype.connect = function () {
	var login = true;
	if (this.smtpAfterPop) {
		login = false;
		this.soc = new Socket();
writeln (this.popHost+':110');
		if (this.soc && this.soc.open (this.popHost+':110')) {
			this.soc.timeout = 10;
			reply = this.read ();
			if (!reply || reply.substr(0,1)!='+')
				this.error = 'Unknow server';
			else {
				this.write ('USER '+this.popUser+'\n');
				reply = this.read ();
				if (!reply || reply.substr(0,1)!='+')
					this.error = 'Unknow user account';
				else {
					this.write ('PASS '+this.popPasswd+'\n');
					reply = this.read ();
					if (!reply || reply.substr(0,1)!='+')
						this.error = 'Wrong password';
					else {
						this.write ('STAT\n');
						this.write ('QUIT');
						this.soc.close();
						this.soc = false;
						login = true;
					}
				}
			}
		}
		else
			this.error = 'Socket connection error';
	}

	if (login) {
		this.soc = new Socket();
writeln (this.smtpHost+':25');
		if (this.soc && this.soc.open (this.smtpHost+':25')) {
			this.soc.timeout = 10;
			if (this.check ())
				return true;
			else
				this.error = 'Unknow server';
		}
		else
			this.error = 'Socket connection error';
	}
	return false;
}

EMail.prototype.send = function () {
	if (!this.from || !this.to || !this.data) {
		this.error = 'Missing data';
		return false;
	}
	var data = 'From: '+this.from+'\n';
	data += 'Reply-To: '+this.from+'\n';
	data += 'To: '+this.to+'\n';
	for (var attr in this.header)
		data += attr+': '+this.header[attr]+'\n';
writeln (data);
	data += '\n'+this.data+'\n.\n';
	if (this.soc &&
			this.write ('HELO '+this.smtpHost+'\n') &&
			this.check () &&
			this.write ('MAIL FROM: '+this.from+'\n') &&
			this.check () &&
			this.write ('RCPT TO: '+this.to+'\n') &&
			this.check () &&
			this.write ('DATA\n') &&
			this.check () &&
			this.write (data) &&
			this.check () &&
			this.write ('QUIT'))
		return true;
	return false;
}

EMail.prototype.disconnect = function () {
	if (this.soc)
		this.soc.close();
	this.soc = false;
	return true;
}

EMail.prototype.write = function (data) {
	if (this.soc) {
writeln ('write '+data);
		this.soc.write (data);
		return true;
	}
	else
		this.error = 'No connection';
	return false;
}

EMail.prototype.read = function () {
	if (this.soc) {
		var reply = '';
		var tmp = '';
		do {
			tmp = this.soc.read();
			reply += tmp;
		} while (tmp.length>0 && tmp.indexOf('\n') != tmp.length-1);
writeln ('read '+reply);
		return reply;
	}
	else
		this.error = 'No connection';
	return false;
}

EMail.prototype.check = function () {
	if (this.soc) {
		var reply = this.soc.read();
writeln ('check '+reply);
		if (!reply) {
			this.error = 'no server response';
			return false;
		}
		else {
			if (parseInt(reply.substr(0, 3))<400)
				return true;
			else {
				this.error = reply;
				return false;
			}
		}
	}
	else
		this.error = 'No connection';
	return false;
}